apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ rgw_name }}-mb-helpers
  namespace: {{ namespace }}
data:
  helpers.sh: |
    MC=/usr/bin/mc;

    if test -z "$REGION"; then
        if test -s /input/region; then
            REGION=$(cat /input/region 2>/dev/null);
        fi;
        if test -z "$REGION"; then
            REGION=us-east-1;
        fi;
    fi;

    connectToRadosGW() {
        ATTEMPTS=0;
        LIMIT=29;
        ACCESS=$(cat /input/access-key 2>/dev/null);
        SECRET=$(cat /input/secret-key 2>/dev/null);
        ENDPOINT=$(cat /input/endpoint 2>/dev/null);
        if test -z "$ACCESS" -o -z "$SECRET" -o -z "$ENDPOINT"; then
            echo "Failed connecting to RadosGW - missing input";
            exit 1;
        fi;
        echo "Connecting to RadosGW - $ENDPOINT";
        while ! $MC config host add myrgw "$ENDPOINT" "$ACCESS" "$SECRET";
        do
            ATTEMPTS=`expr $ATTEMPTS + 1`;
            echo "Failed attempts: $ATTEMPTS";
            if test $ATTEMPTS -gt $LIMIT; then
                exit 1;
            fi;
            sleep 2;
        done;
        echo Connected to RadosGW;
        return 0;
    }

    checkBucketExists() {
        BUCKET="$1";
        $MC ls "myrgw/$BUCKET" >/dev/null 2>&1;
        return $?;
    }

    createBucket() {
        PURGE=$1;
        BUCKET=$(cat /input/bucket 2>/dev/null);
        if test -z "$BUCKET"; then
            echo "Failed - bucket name not found";
            return 1;
        fi
        if test "$PURGE" = true; then
            if checkBucketExists "$BUCKET"; then
                echo "Purging bucket $BUCKET.";
                $MC rm -r --force "myrgw/$BUCKET";
            else
                echo "Bucket '$BUCKET' does not exist, skipping purge.";
            fi;
        fi;
        if ! checkBucketExists "$BUCKET"; then
            echo "Creating bucket $BUCKET";
            if ! $MC mb "myrgw/$BUCKET" --region=$REGION; then
                echo "Failed creating bucket $BUCKET";
                return 1;
            fi;
        else
            echo "Bucket $BUCKET already exists.";
        fi;
    }
